// CChildDlg.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "base.h"
#include "CChildDlg.h"

//^C}[ID
#define TIMER_ID1	100

#ifdef _DEBUG
	#define TIMER_ID1TIME	10000
#else
	#define TIMER_ID1TIME	30000
#endif



#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CChildDlg _CAO


CChildDlg::CChildDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CChildDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CChildDlg)
	m_strIPAddress = _T("");
	//}}AFX_DATA_INIT
}


void CChildDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CChildDlg)
	DDX_Control(pDX, IDOK, m_cltBtnOk);
	DDX_Text(pDX, IDC_EDIT_GLOBALIP, m_strIPAddress);
	DDX_Text(pDX, IDC_EDIT_SERVER, m_strServer);
	DDX_Check(pDX, IDC_CHECK_FIRSTHIDEWINDOW, m_bChkFirsthidewindow);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CChildDlg, CDialog)
	//{{AFX_MSG_MAP(CChildDlg)
	ON_WM_DESTROY()
	ON_COMMAND(IDM_EXIT, OnMenuExit)
	ON_COMMAND(IDM_VERSION, OnMenuVersion)
	ON_WM_TIMER()
	ON_WM_CLOSE()
	ON_BN_CLICKED(IDC_BUTTON_HIDE, OnButtonHide)
	//}}AFX_MSG_MAP
	ON_MESSAGE(WM_CHECKEDIP,OnCheckedIP)
	ON_BN_CLICKED(IDC_CHECK_FIRSTHIDEWINDOW, &CChildDlg::OnBnClickedCheckFirsthidewindow)
	ON_BN_CLICKED(IDC_BUTTON_COPY, &CChildDlg::OnBnClickedButtonCopy)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CChildDlg bZ[W nh

BOOL CChildDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: ̈ʒuɏ̕⑫ǉĂ
	m_stNotifyIcon.cbSize = sizeof(NOTIFYICONDATA);
	m_stNotifyIcon.uID = 0;
	m_stNotifyIcon.hWnd = m_hWnd;
	m_stNotifyIcon.uFlags = NIF_ICON | NIF_MESSAGE | NIF_TIP;
	m_stNotifyIcon.hIcon = AfxGetApp()->LoadIcon( IDR_MAINFRAME );
	m_stNotifyIcon.uCallbackMessage = WM_USER_POPUP;
	m_stNotifyIcon.uTimeout = 1000;
	m_stNotifyIcon.dwInfoFlags = 0 ;
						// 0 
						// 1 CtH[V   
						// 2 x                 
						// 3 oc                 
						// 4 g̃ACR   
	lstrcpy( m_stNotifyIcon.szInfo, "" );
	lstrcpy( m_stNotifyIcon.szInfoTitle, "IP Address" );
	lstrcpy( m_stNotifyIcon.szTip, DEF_VERSION );
	Shell_NotifyIcon( NIM_ADD, &m_stNotifyIcon );
	m_stNotifyIcon.uFlags = NIF_ICON | NIF_MESSAGE | NIF_TIP | NIF_INFO;



	m_nWindowflag = SWP_SHOWWINDOW;

	//NɃEBhEBΉ2010.11.05 
	if(AfxGetApp()->GetProfileInt(DEF_INI_SECTION_NAME
		,DEF_INI_FIRSTHIDEWINDOW
		,DEF_INI_FIRSTHIDEWINDOW_DEFAULT) == TRUE) {
	  	//ChangeWindowPos();
		
		CRect rMyDlgRect;
		GetWindowRect(&rMyDlgRect);

		SetWindowPos(&wndTopMost,
			-rMyDlgRect.Size().cx ,-rMyDlgRect.Size().cy, 
			0,0,
			SWP_SHOWWINDOW | SWP_NOSIZE | SWP_NOACTIVATE | SWP_NOZORDER);

		m_nWindowflag = SWP_HIDEWINDOW;

		m_bChkFirsthidewindow = TRUE;
	}

	m_pGetIPThread = NULL;

	m_bCheckIPTime = FALSE;
	m_strLastGlobalIPAddress ="";
	m_strLastLocalIPAddress ="";
	m_nLogCount = 0;

	//Rg[ɒl
	m_strIPAddress = "";
	m_strServer = "";
	m_cltBtnOk.SetWindowText(DEF_BUTTON_TXT1);

	//O̓ǂݏo
	if(ReadLogFile(m_strIPAddress)) {
		UpdateData(FALSE);
	}

	m_nTimerID1 = TIMER_ID1TIME;
	SetTimer(TIMER_ID1, m_nTimerID1/10, NULL);
	m_bCheckIPTime = TRUE;

	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

BOOL CChildDlg::DestroyWindow() 
{
	// TODO: ̈ʒuɌŗL̏ǉ邩A܂͊{NXĂяoĂ
	
	return CDialog::DestroyWindow();
}

void CChildDlg::OnDestroy() 
{
	CDialog::OnDestroy();
	
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉĂ
	Shell_NotifyIcon( NIM_DELETE, &m_stNotifyIcon );

	if(m_pGetIPThread!=NULL) {
		m_pGetIPThread->SuspendThread();
		m_pGetIPThread->Delete();
		m_pGetIPThread=NULL;
	}

}

LRESULT CChildDlg::WindowProc(UINT message, WPARAM wParam, LPARAM lParam) 
{
	// TODO: ̈ʒuɌŗL̏ǉ邩A܂͊{NXĂяoĂ
	static UINT s_uTaskbarRestart;//^XNo[Vɍ쐬ꂽƂɃACRĂѕ\̂Ɏg

	switch(message) {
		case WM_CREATE:
			s_uTaskbarRestart = RegisterWindowMessage(TEXT("TaskbarCreated"));
			break;

		case WM_USER_POPUP:
			// J[\݈̌ʒu擾
			POINT point;
			GetCursorPos(&point);

			if( lParam == WM_RBUTTONDOWN) {
				//j[\

				SetForegroundWindow();	// őOʕ\@̏YꂸɁI
				CMenu menu;
				VERIFY(menu.LoadMenu(IDR_MENU1));
				CMenu* pPopup = menu.GetSubMenu(0);
				ASSERT(pPopup != NULL);
				pPopup->TrackPopupMenu(TPM_LEFTALIGN | TPM_RIGHTBUTTON, point.x, point.y, this);
				PostMessage(WM_NULL);	// ̏YꂸɁI
			} else if( lParam == WM_LBUTTONDOWN ) {
				// ^XNgCACRNbNƃEBhE̕\^\؂ւ鏈

				ChangeWindowPos();
			} else if ( lParam == NIN_BALLOONUSERCLICK) {
				//o[NbN
				ChangeWindowPos();
			}
			break;

		default:
			if(message == s_uTaskbarRestart) {//ĕ`
				Shell_NotifyIcon( NIM_DELETE, &m_stNotifyIcon );
				Shell_NotifyIcon( NIM_ADD, &m_stNotifyIcon );
			}
	}

	return CDialog::WindowProc(message, wParam, lParam);
}

void CChildDlg::OnMenuExit() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	CDialog::OnOK();
}

void CChildDlg::OnMenuVersion() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	AfxMessageBox(DEF_VERSION);
}

void CChildDlg::OnOK() 
{
	// TODO: ̈ʒuɂ̑̌ؗp̃R[hǉĂ

	if(m_bCheckIPTime == FALSE) {

		SetTimer(TIMER_ID1, 1, NULL);
		m_bCheckIPTime = TRUE;

		m_cltBtnOk.SetWindowText(DEF_BUTTON_TXT1);
	} else {
		KillTimer(TIMER_ID1);
		m_bCheckIPTime = FALSE;

		m_strLastGlobalIPAddress = "";
		m_strLastLocalIPAddress = "";
		m_cltBtnOk.SetWindowText(DEF_BUTTON_TXT2);
	}

//	CDialog::OnOK();
}

void CChildDlg::OnCancel() 
{
	// TODO: ̈ʒuɓʂȌ㏈ǉĂB



	CDialog::OnCancel();
}

void CChildDlg::ChangeWindowPos()
{
	if(this->m_nWindowflag == SWP_HIDEWINDOW)
	{
		//EBhE

		CRect rMyDlgRect,rAnimation;

		rAnimation.right	= GetSystemMetrics(SM_CXSCREEN);
		rAnimation.bottom	= GetSystemMetrics(SM_CYSCREEN);
		rAnimation.left	= rAnimation.right;
		rAnimation.top	= rAnimation.bottom;


		GetWindowRect(&rMyDlgRect);
		//2011/04/27炩̌ŉʊOɏoƂ͒\
		if(rMyDlgRect.bottom < 0 || rMyDlgRect.left < 0
			|| rMyDlgRect.left > rAnimation.right || rMyDlgRect.top > rAnimation.bottom ) {
			CenterWindow();
			GetWindowRect(&rMyDlgRect);
		}

		//Aj[V
		DrawAnimatedRects(IDANI_CAPTION,rAnimation,rMyDlgRect);

		ShowWindow(SW_SHOW);
		this->SetForegroundWindow();

		m_nWindowflag = SWP_SHOWWINDOW;

	}else{
		//EBhE

		CRect rMyDlgRect,rAnimation;

		rAnimation.right	= GetSystemMetrics(SM_CXSCREEN);
		rAnimation.bottom	= GetSystemMetrics(SM_CYSCREEN);
		rAnimation.left		= rAnimation.right;
		rAnimation.top		= rAnimation.bottom;


		GetWindowRect(&rMyDlgRect);
		
		//2011/04/27炩̌ŉʊOɏoƂ͒\
		if(rMyDlgRect.bottom < 0 || rMyDlgRect.left < 0
			|| rMyDlgRect.left > rAnimation.right || rMyDlgRect.top > rAnimation.bottom ) {
			CenterWindow();
			GetWindowRect(&rMyDlgRect);
		}

		DrawAnimatedRects(IDANI_CAPTION,rMyDlgRect,rAnimation);

		ShowWindow(SW_HIDE);


		m_nWindowflag = SWP_HIDEWINDOW;		
	}

}

void CChildDlg::OnTimer(UINT nIDEvent) 
{
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉ邩܂̓ftHg̏ĂяoĂ

	if(nIDEvent == TIMER_ID1) {

		KillTimer(TIMER_ID1);

		if(m_pGetIPThread==NULL) {
			//
			try {

				CRuntimeClass *pRuntime = RUNTIME_CLASS(CGetIPAddressThread);
				m_pGetIPThread = (CGetIPAddressThread*)pRuntime->CreateObject();
				m_pGetIPThread->SetResWnd(this->GetSafeHwnd());
				m_pGetIPThread->CreateThread(0, 0, NULL);

			} catch (CException *eP) {

				eP->Delete();
				if(m_pGetIPThread!=NULL) {
					m_pGetIPThread->Delete();
					m_pGetIPThread=NULL;
				}
			}
		} else {

			if(m_pGetIPThread->IsChecking()==FALSE) {
				//`FbNׂ̈̃bZ[W΂
				m_pGetIPThread->PostThreadMessage(WM_CHECKIP,0,(LPARAM)this->GetSafeHwnd());
			}
		}		
		SetTimer(TIMER_ID1, m_nTimerID1, NULL);
	}

	CDialog::OnTimer(nIDEvent);
}

BOOL CChildDlg::GetIPAddress()
{
	BOOL bRes = FALSE;

	if(m_pGetIPThread==NULL) {
		return bRes;
	}

	try {
	CString strGIP,strLIP;
	if(m_pGetIPThread->IsChecked()){
		m_pGetIPThread->GetGlobalIPAddress(strGIP);
		m_pGetIPThread->GetLocalIPAddress(strLIP);

		if((m_strLastGlobalIPAddress != strGIP && strGIP.GetLength() > 3)
			|| (m_strLastLocalIPAddress !=  strLIP && strLIP.GetLength() > 3)) {

			UpdateData(TRUE);
			CTime tm = CTime::GetCurrentTime();

			CString strTime;
			strTime = tm.Format("%Y/%m/%d %H:%M:%S");

			CString strBuf;
			strBuf.Format(DEF_TEXTFORMAT_IP,strTime,strGIP,strLIP);
			m_strIPAddress = strBuf + m_strIPAddress;

			//Oő匏𒴂Ō̍s
			m_nLogCount++;
			if(m_nLogCount > READBUFFER_MAX) {

				CString str =	m_strIPAddress.Left(m_strIPAddress.GetLength() - 2);
				int nPos = str.ReverseFind('\n');
				m_strIPAddress = str.Left(nPos);

			}

			m_strLastGlobalIPAddress = strGIP;
			m_strLastLocalIPAddress = strLIP;

			//Oc
			WriteLogFile(m_strIPAddress);

			m_strServer = m_pGetIPThread->GetLastGetServer();

			//ʒm̈
			CString strInfoBuf,strTip;
			strInfoBuf.Format(DEF_TASKTRAY_MSG,m_strLastGlobalIPAddress,m_strLastLocalIPAddress);
			lstrcpy( m_stNotifyIcon.szInfo , strInfoBuf );
			strTip.Format("%s \r\n%s",DEF_VERSION,strInfoBuf);
			lstrcpy( m_stNotifyIcon.szTip , strTip );

			Shell_NotifyIcon( NIM_MODIFY, &m_stNotifyIcon );

			UpdateData(FALSE);

			bRes = TRUE;
		}
	}
	} catch (CException *eP) {

		eP->Delete();
		bRes = FALSE;
	}

	return bRes;
}


BOOL CChildDlg::WriteLogFile(CString strLog)
{
	BOOL bRes =FALSE;
	BOOL bOpen =FALSE;

	CString strLogFileName;

	//Ot@C̃pX{t@C
	strLogFileName = AFXGETAPP()->GetLogFileName();

	CFile    stdFile;
	try {
		if(stdFile.Open(strLogFileName, 
				CFile::modeWrite | CFile::shareDenyNone | CFile::modeCreate | CFile::modeNoTruncate
				)) {
			bOpen = TRUE;
			stdFile.SetLength(0);
			stdFile.Write(strLog,strLog.GetLength());
			stdFile.Close();

			bRes = TRUE;
		}
	}
	catch (CFileException *eP) {

		eP->Delete();
		if (bOpen = TRUE) {
			stdFile.Close();
		}
		bRes = FALSE;
	}


	return bRes;
}
BOOL CChildDlg::ReadLogFile(CString& strLog)
{
	BOOL bRes =FALSE;
	BOOL bOpen =FALSE;

	CString strLogFileName;

	//Ot@C̃pX{t@C
	strLogFileName = AFXGETAPP()->GetLogFileName();


	CStdioFile    stdFile;
	strLog="";
	int iCount = 0;

	CString strReadBuffer;

	try {
		if(stdFile.Open(strLogFileName,CFile::modeRead | CFile::shareDenyNone)) {
			bOpen = TRUE;
			for(iCount = 0;iCount<=READBUFFER_MAX && stdFile.GetPosition()<stdFile.GetLength();iCount++) {
				strReadBuffer = "";
				stdFile.ReadString(strReadBuffer);

				//START 2011/04/27
				//Ver1.3.0.0ȑOŃOt@CɖʂȉsĂ܂s΍
				int iPosLF = strReadBuffer.FindOneOf("\r\n");
				if( iPosLF > -1) {
					CString s = strReadBuffer;
					strReadBuffer = s.Left(iPosLF);
				}

				if(strReadBuffer.GetLength() > 3) {
					strLog = strLog + strReadBuffer + "\r\n";

					//O̓ǂݍ݃JEg
					m_nLogCount++;
				}
				//END 2011/04/27

			}
			bRes = TRUE;
			stdFile.Close();
		}
	}
	catch (CFileException *eP) {

		eP->Delete();
		if (bOpen = TRUE) {
			stdFile.Close();
		}
	}


	return bRes;
}

void CChildDlg::OnClose() 
{
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉ邩܂̓ftHg̏ĂяoĂ

	//~{^NbN
	ChangeWindowPos();
//	CDialog::OnClose();
}

LRESULT	CChildDlg::OnCheckedIP(WPARAM wParam,LPARAM lParam)
{

	GetIPAddress();
	return 0;
}
void CChildDlg::OnButtonHide() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	ChangeWindowPos();
}

void CChildDlg::OnBnClickedCheckFirsthidewindow()
{
	// TODO: ɃRg[ʒmnh R[hǉ܂B

	//NɃEBhEB`FbN

	UpdateData(TRUE);

	AfxGetApp()->WriteProfileInt(
		DEF_INI_SECTION_NAME
		,DEF_INI_FIRSTHIDEWINDOW
		,m_bChkFirsthidewindow
		);

}

void CChildDlg::OnBnClickedButtonCopy()
{
	// TODO: ɃRg[ʒmnh R[hǉ܂B

	if(m_strLastGlobalIPAddress.GetLength() <= 0) {
		return;
	}
    
    //Nbv{[hJ
    if (OpenClipboard()){
		char *szCopy;
		HGLOBAL hMem;

		//O[öɊm
		hMem = GlobalAlloc(GMEM_MOVEABLE, m_strLastGlobalIPAddress.GetLength()+1);

	    //O[ö(hMem)Ƀf[^i[
		szCopy = (char*)GlobalLock(hMem); 
//		strcpy(szCopy, m_strLastGlobalIPAddress);
		lstrcpy(szCopy,m_strLastGlobalIPAddress);
		GlobalUnlock(hMem); 
		//Nbv{[hɂ
		EmptyClipboard();
		//Nbv{[hփeLXgi[
		HANDLE hData = SetClipboardData(CF_TEXT, hMem);
		//Nbv{[h
		CloseClipboard();
		GlobalFree(hMem);   
    }

}
