// CIPAddress.cpp: CIPAddress NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "CIPAddress.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

CIPAddress::CIPAddress()
{
	Init();
}

CIPAddress::~CIPAddress()
{
	m_strArrayServer.RemoveAll();
}

void CIPAddress::Init()
{
	m_strArrayServer.RemoveAll();

	m_strArrayServer.Add("http://www.dyndns.org/cgi-bin/check_ip.cgi");
	m_strArrayServer.Add("http://checkip.dyndns.org/");

	m_strLastGetServer = "";
}

int CIPAddress::GetGlobalIPAddress(CString& strIPAddress)
{

	int nRes = FALSE_GET;
	CString strValue;
	
	nRes = GetInternetFile(strValue);

	try{
		if(nRes == TRUE_GET && strValue.GetLength() > 0) {

			strValue.MakeUpper();
			int nFindIPPos		= strValue.Find("ADDRESS:",0);
			int nFindIPPiriod1	= strValue.Find(".",nFindIPPos+1);
			int nFindIPPiriod2	= strValue.Find(".",nFindIPPiriod1+1);
			int nFindIPPiriod3	= strValue.Find(".",nFindIPPiriod2+1);
			int nFindIPendPos;


			if(nFindIPPos != -1
				&& nFindIPPiriod1 != -1
				&& nFindIPPiriod2 != -1
				&& nFindIPPiriod3 != -1
				&& strValue.GetLength() > nFindIPPiriod3 + 3
				) {

				int i;
				for(i=1;i<4;i++) {
					char c = strValue.GetAt(nFindIPPiriod3+i);

					if(c < '0' || c > '9') {
						break;
					}
				}

				nFindIPendPos = nFindIPPiriod3+i;
				strIPAddress.Format("%s"
					,strValue.Mid((nFindIPPos+8),nFindIPendPos-(nFindIPPos+8))
								);

				strIPAddress.TrimLeft();//擪̋󔒍s菜

			}

		}

	} catch (CException *eP) {

		eP->Delete();
		nRes = FALSE_GET;
		strIPAddress="";
	}


	return nRes;
}

BOOL CIPAddress::GetPraivateIPAddress(CString& strIPAddress)
{

	BOOL bRes = FALSE;

	HOSTENT *lpHost = NULL;
	IN_ADDR inaddr;
	WSADATA wsadata;
	char szBuf[256];

	memset(szBuf,NULL,256);

	try{

		WSAStartup(MAKEWORD(1, 1), &wsadata);
		gethostname(szBuf, (int)sizeof(szBuf));

		lpHost = gethostbyname(szBuf);
		if(lpHost != NULL) {

			memcpy(&inaddr, lpHost->h_addr_list[0], 4);
//			strBuf.Format("%s",inet_ntoa(inaddr));
			strIPAddress.Format("%d.%d.%d.%d",inaddr.S_un.S_un_b.s_b1
										,inaddr.S_un.S_un_b.s_b2
										,inaddr.S_un.S_un_b.s_b3
										,inaddr.S_un.S_un_b.s_b4
										);

			bRes = TRUE;
		} else {
			strIPAddress = "";
			bRes = FALSE;
		}

		WSACleanup();

	} catch (CException *eP) {

		eP->Delete();
		bRes = FALSE;
		strIPAddress = "";
	}


	return bRes;
}

int CIPAddress::GetInternetFile(CString& str)
{

	HINTERNET hInet = NULL;
	HINTERNET hFile = NULL;
	char szBuf[1024];
	DWORD dwSize = 0;

	memset(szBuf,NULL,1024);

	/* nh쐬 */
	hInet=InternetOpen("CIPAddress",INTERNET_OPEN_TYPE_DIRECT,
	       NULL,NULL,0);
	if(hInet == NULL) {
		return FALSE_INTERNETHANLDE;
	}

	int	nCount;
	for(nCount = 0;nCount<m_strArrayServer.GetSize() && hFile == NULL;nCount++) {

		try{

			m_strLastGetServer = m_strArrayServer.GetAt(nCount);

			/* URLI[v */
			hFile=InternetOpenUrl(hInet
				,m_strLastGetServer
				,NULL
				,-1
				,INTERNET_FLAG_RELOAD
				,0);

			if(hFile != NULL) {
				/* t@Cǂݍ */
				InternetReadFile(hFile,szBuf,1023,&dwSize);
				if(strlen(szBuf) > 0 ) {
					str.Format("%s",szBuf);
				}
			}


		} catch (CException *eP) {

			eP->Delete();

			if(hFile!=NULL) {
				InternetCloseHandle(hFile);
			}
			InternetCloseHandle(hInet);

			return FALSE_OTHER;
		}
	}

	/* I */
	if(hFile != NULL) {
		InternetCloseHandle(hFile);
		InternetCloseHandle(hInet);
	} else {
		InternetCloseHandle(hInet);
		return FALSE_SERVEROPEN;
	}

	return TRUE_GET;
}